package cn.com.ty.lift.push.message.controller;

import cn.com.ty.lift.push.message.dao.entity.TimeMessage;
import cn.com.ty.lift.push.message.object.MessageBO;
import cn.com.ty.lift.push.message.object.MessageVo;
import cn.com.ty.lift.push.message.service.TimeMessageService;
import cn.com.xwy.boot.web.dto.RestResponse;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@AllArgsConstructor
@RequestMapping("message")
public class TimeMessageController {
    private final TimeMessageService timeMessageService;

    @PostMapping("list")
    public RestResponse list(@RequestBody MessageVo messageVo) {
        IPage<TimeMessage> page = new Page<>(messageVo.getPageNum(), messageVo.getPageSize());
        IPage<TimeMessage> result = timeMessageService.page(page, Wrappers.<TimeMessage>query()
                .eq(messageVo.getType() != null, "type", messageVo.getType())
                .orderByAsc("view_flag", "create_time"));
        MessageBO messageBO = MessageBO.pageCastMessageBo(result);
        messageBO.setReadCount(timeMessageService.count(Wrappers.<TimeMessage>query()
                .eq("view_flag", 1)
                .eq("type", messageVo.getType())));
        messageBO.setUnreadCount(timeMessageService.count(Wrappers.<TimeMessage>query()
                .eq("view_flag", 0)
                .eq("type", messageVo.getType())));
        return RestResponse.success(messageBO);
    }

    @PostMapping
    public RestResponse message(@RequestBody MessageVo messageVo) {
        TimeMessage byId = timeMessageService.getById(messageVo.getId());
        byId.setViewFlag(1);
        return RestResponse.success(byId);
    }
}
